package sockprog.example1_hello;

import java.io.*;
import java.net.Socket;

final class EchoClientHandler implements Runnable {
    private final Socket socket;

    EchoClientHandler(Socket socket) {
        this.socket = socket; 
    }
    
    public void run() { // [1]
        try {
            handleClient();
        } catch (IOException e) {
            e.printStackTrace();
        } finally {
            try {
                socket.close();
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
    }

    private void handleClient() throws IOException { // [2]
        // readerの準備
        InputStream in = socket.getInputStream();
        InputStreamReader inReader = 
            new InputStreamReader(in, ProtocolConstants.ENCODING);
        BufferedReader reader = new BufferedReader(inReader);

        // writerの準備
        OutputStream out = socket.getOutputStream();
        OutputStreamWriter outWriter = 
            new OutputStreamWriter(out, ProtocolConstants.ENCODING);
        Writer writer = new BufferedWriter(outWriter);

        // 読み込みが終わるまでEchoループ
        for(String message = reader.readLine(); 
            message != null; message = reader.readLine())
        {
            writer.write(message);
            writer.write(ProtocolConstants.LINE_SEPARATOR);
            writer.flush();
            System.out.println(message);
        }
    }
}
