package sockprog.example1_hello;

import java.io.IOException;
import junit.framework.TestCase;

public class EchoTest extends TestCase {
    private MessageServer server;
    private final String HOST = "localhost";
    private final int PORT = 8888;

    protected void setUp() throws Exception {
        server = new MessageServer(PORT);
        server.start();  // [1]
    }

    protected void tearDown() throws Exception {
        server.shutDown(); // [2]
    }

    public void testHelloWorld() throws IOException { // [3]
        MessageClient client = null;
        try {
            client = new MessageClient(HOST, PORT);
            String message = "Hello, World!";
            String reply = client.send(message);
            assertEquals(message, reply);
            reply = client.send(message);
            assertEquals(message, reply);
        } finally {
            if(client != null) {
                client.shutDown();
            }
        }
    }
}
