# -*- coding: utf-8 -*-
# ↑Emacsで文字コードを強制するときのタグです。

# 警告レベルを上げるpragmaです。Perlでコーディングするときは必須です。
use strict;
use warnings;

# 名前空間を指定します。定数定義だけだとあまり意味がないかもしれませんが……。
package MCConfig;

# ・スーパークラスを指定します。
#     http://perl-users.jp/nowpast.html
#   によると、今風な継承は「use parent」だそうですが、
#   5.10以降でしか使えません。
# ・Exporterはモジュール内で定義したシンボルをエクスポートします。
#   詳細は「perldoc Exporter」を参照してください。
use base qw(Exporter);

# デフォルトでエクスポートするシンボルは、@EXPORTに列挙します。
# 「use モジュール名」に続く引数のシンボルのみエクスポートする場合には、
# @EXPORT_OKに列挙します。
# 1つの引数で複数のシンボルをエクスポートする場合には、%EXPORT_TAGSに
# 引数(タグ)とシンボル列の対応を列挙します。
# 詳細は「perldoc Exporter」を参照のこと。
our @EXPORT = qw( MULTICAST_ADDR4 MULTICAST_ADDR6
                  MULTICAST_PORT SEND_NAME SEND_INTERVAL
                  RECV_BUF_SIZE DISP_INTERVAL DISP_EXPIRES
               );

# 定数を定義します。「定数」と言っても、実体は関数です。
# なので、文字列中での展開には使えません。
# 詳細は「perldoc constant」を参照してください。
use constant {
    MULTICAST_ADDR6 => "ff35:40:fdb4:353a:c83f:10::10",
    MULTICAST_ADDR4 => "239.255.10.10",
    MULTICAST_PORT => 10101,
    SEND_NAME => "Perl",
    SEND_INTERVAL => 300, # ミリ秒
    RECV_BUF_SIZE => 8 * 1024 + 1,
    DISP_INTERVAL => 1000, # ミリ秒
    DISP_EXPIRES => 10000, # ミリ秒
};

# Perlを知っている人には今さらでしょうが、モジュールの読み込みに成功した
# 場合は真を返す必要があります。普通はファイルの末尾に「1;」と書きます。
# 詳細は「perldoc -f require」を参照してください。
1;
