#!/usr/bin/perl
# -*- coding: utf-8 -*-
# ↑Emacsで文字コードを強制するときのタグ。

### 送信用スクリプトです。なお、Cygwinではcygwin1.dllの関係でIPv6が使えません。

# 警告レベルを上げるpragma。Perlでコーディングするときは必須。
use strict;
use warnings;

# 今回主役のモジュール。
use IO::Socket::Multicast6;

# receiver.plを参照のこと。
use Time::HiRes qw(usleep);

# 今回定義した定数の読み込み。
use MCConfig;

# 送信処理
sub sender {
    my ($domain, $addr) = @_;
    my $msock = IO::Socket::Multicast6->new(
        Proto => 'udp',
        Domain => $domain,
        PeerAddr => $addr,
        PeerPort => MULTICAST_PORT)
      or die "Couldn't initialize multicast socket: $!";
    my $i = 0;
    while (1) {
        $msock->send(++$i.' '.SEND_NAME);
        usleep(SEND_INTERVAL * 1000); # ミリ秒→マイクロ秒
    }
}

# 標準出力をノンバッファリングモードに指定。
$| = 1;

# 引数でIPv4/IPv6を切り替えます。要素の数が0のとき、いきなり$ARGV[0]と書くと、
# use warningsの効果で怒られます。
if (@ARGV && $ARGV[0] eq '6') {
    print "Mode: IPv6\n";
    sender(AF_INET6, MULTICAST_ADDR6);
} else {
    print "Mode: IPv4\n";
    sender(AF_INET, MULTICAST_ADDR4);
}
