#!/usr/bin/ruby
# -*- coding: utf-8 -*-
# ↑Emacsで文字コードを強制するときのタグです。

### 送信用スクリプトです。なお、Cygwinではcygwin1.dllの関係でIPv6が使えません。

require 'socket'
require 'mcconfig'

# 標準出力をノンバッファリングモードに指定します。
$stdout.sync = true

# 引数でIPv4/IPv6を切り替えます。
if ARGV[0] == '6'
  puts "Mode: IPv6"
  domain = Socket::AF_INET6
  addr = MULTICAST_ADDR6
else
  puts "Mode: IPv4"
  domain = Socket::AF_INET
  addr = MULTICAST_ADDR4
end

sock = UDPSocket.open(domain)
sockaddr = Socket.pack_sockaddr_in(MULTICAST_PORT, addr)

# 送信処理です。
i = 0
loop { # 無限ループを行います。カウンタ付きの無限ループは無いようです。
  i += 1
  sock.send("#{i} #{SEND_NAME}", 0, sockaddr)
  sleep(SEND_INTERVAL / 1000.0) # ミリ秒→秒
}
