package mywebserver;

import java.io.BufferedWriter;
import java.io.IOException;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.io.Writer;
import java.util.HashMap;
import java.util.Map;

/**
 * HTTPX|X킷NXB
 */
public class Response {

    private static final String CRLF = "\r\n";

    /**
     * o̓Xg[B
     */
    private final OutputStream os;

    /**
     * wb_B
     */
    private final Map<String, String> headers = new HashMap<String, String>();

    /**
     * X|Xwb_ɑMƂ킷B
     */
    private boolean sentResponseHeader = false;

    /**
     * HTTPX|XIuWFNg\z܂B<br>
     * o̓Xg[ƃX|Xwb_̌Œl܂B
     * 
     * @param os
     *            o̓Xg[B
     */
    public Response(OutputStream os) {
        this.os = os;
        setHeader("Server", "MyWebServer/1.0");
        setHeader("Connection", "close");
    }

    /**
     * X|Xwb_ɐݒ肷lo^܂B
     * 
     * @param fieldName
     *            tB[hB
     * @param fieldValue
     *            tB[hlB
     */
    public void setHeader(String fieldName, String fieldValue) {
        headers.put(fieldName, fieldValue);
    }

    /**
     * X|Xwb_NCAgɑM܂B
     * 
     * @param statusCode
     *            HTTPXe[^XR[hB
     * @throws IOException
     *             X|Xwb_Ԃۂɓo͗OB
     */
    public void sendResponseHeader(int statusCode) throws IOException {
        // Qڈȍ~̌Ăяo͖
        if (sentResponseHeader) {
            return;
        }
        sentResponseHeader = true;
        // X|Xwb_̕R[hUS-ASCII
        Writer writer = new BufferedWriter(new OutputStreamWriter(os,
                "US-ASCII"));
        setHeader("Date", Utils.getDate());
        sendStatusLine(writer, statusCode);
        sendHeaders(writer);
        writer.write(CRLF);
        writer.flush();
    }

    /**
     * bZ[W{̂o͂Xg[擾܂B
     * 
     * @return bZ[W{̂o͂Xg[B
     */
    public OutputStream getMessageBody() {
        return os;
    }

    /**
     * w肳ꂽXe[^XR[h̃Xe[^XCo͂܂B
     * 
     * @param statusCode
     *            Xe[^XR[hB
     * @param writer
     *            o͐B
     * @throws IOException
     */
    private void sendStatusLine(Writer writer, int statusCode)
            throws IOException {
        writer.write("HTTP/1.1 " + statusCode + " "
                + Utils.getStatusPhrase(statusCode) + CRLF);
    }

    /**
     * wb_o͂܂B
     * 
     * @param writer
     *            o͐B
     * @throws IOException
     */
    private void sendHeaders(Writer writer) throws IOException {
        for (Map.Entry<String, String> e : headers.entrySet()) {
            writer.write(e.getKey() + ": " + e.getValue() + CRLF);
        }
    }

}
